﻿using Correo.Abstractions;
using System.Collections.Generic;
using System.Net.Mail;

namespace Correo.SmtpClient.Extensions
{
    internal static class ModelExtensions
    {
        private static MailAddress ToMailAddress(this EmailMessage.MailAddress address)
            => new MailAddress(address.Address, address.DisplayName);

        private static void AddRange(this MailAddressCollection collection, IEnumerable<EmailMessage.MailAddress> addresses)
        {
            foreach (var item in addresses)
                collection.Add(item.ToMailAddress());
        }

        public static MailMessage ToMailMessage(this EmailMessage message)
        {
            var mailMessage = new MailMessage
            {
                Subject = message.Subject,
                Body = message.Body,
                From = message.From.ToMailAddress(),
                IsBodyHtml = message.IsBodyHtml
            };

            mailMessage.To.AddRange(message.To);
            mailMessage.CC.AddRange(message.Cc);
            mailMessage.Bcc.AddRange(message.Bcc);

            return mailMessage;
        }
    }
}
